'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MIN_ZOOM = 1;
var MAX_ZOOM = 3;

var Cropper = function (_React$Component) {
  _inherits(Cropper, _React$Component);

  function Cropper() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Cropper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Cropper.__proto__ || Object.getPrototypeOf(Cropper)).call.apply(_ref, [this].concat(args))), _this), _this.image = null, _this.imageSize = { width: 0, height: 0, naturalWidth: 0, naturalHeight: 0 }, _this.dragStartPosition = { x: 0, y: 0 }, _this.dragStartCrop = { x: 0, y: 0 }, _this.rafTimeout = null, _this.state = {
      cropSize: null
    }, _this.cleanEvents = function () {
      document.removeEventListener('mousemove', _this.onDrag);
      document.removeEventListener('touchmove', _this.onDrag);
      document.removeEventListener('mouseup', _this.dragStopped);
      document.removeEventListener('touchend', _this.dragStopped);
    }, _this.onImgLoad = function () {
      _this.computeSizes();
      _this.emitCropData();
    }, _this.computeSizes = function () {
      if (_this.image) {
        _this.imageSize = {
          width: _this.image.width,
          height: _this.image.height,
          naturalWidth: _this.image.naturalWidth,
          naturalHeight: _this.image.naturalHeight
        };
        var cropSize = void 0;
        if (_this.image.width >= _this.image.height * _this.props.aspect) {
          cropSize = {
            width: _this.image.height * _this.props.aspect,
            height: _this.image.height
          };
        } else {
          cropSize = {
            width: _this.image.width,
            height: _this.image.width / _this.props.aspect
          };
        }
        _this.setState({ cropSize: cropSize }, _this.recomputeCropPosition);
      }
    }, _this.dragStart = function (e) {
      e.preventDefault();

      var _Cropper$getEventXY = Cropper.getEventXY(e),
          x = _Cropper$getEventXY.x,
          y = _Cropper$getEventXY.y;

      _this.dragStartPosition = { x: x, y: y };
      _this.dragStartCrop = { x: _this.props.crop.x, y: _this.props.crop.y };
      document.addEventListener('mousemove', _this.onDrag);
      document.addEventListener('touchmove', _this.onDrag);
      document.addEventListener('mouseup', _this.dragStopped);
      document.addEventListener('touchend', _this.dragStopped);
    }, _this.onDrag = function (e) {
      if (_this.rafTimeout) window.cancelAnimationFrame(_this.rafTimeout);

      _this.rafTimeout = window.requestAnimationFrame(function () {
        var _Cropper$getEventXY2 = Cropper.getEventXY(e),
            x = _Cropper$getEventXY2.x,
            y = _Cropper$getEventXY2.y;

        if (x === undefined || y === undefined) return;
        var offsetX = x - _this.dragStartPosition.x;
        var offsetY = y - _this.dragStartPosition.y;

        _this.props.onCropChange({
          x: Cropper.restrictDrag(_this.dragStartCrop.x + offsetX, _this.imageSize.width, _this.state.cropSize.width, _this.props.zoom),
          y: Cropper.restrictDrag(_this.dragStartCrop.y + offsetY, _this.imageSize.height, _this.state.cropSize.height, _this.props.zoom)
        });
      });
    }, _this.dragStopped = function () {
      _this.cleanEvents();
      _this.emitCropData();
    }, _this.onWheel = function (e) {
      e.preventDefault();
      var newZoom = _this.props.zoom - e.deltaY / 200;
      newZoom = Math.min(MAX_ZOOM, Math.max(newZoom, MIN_ZOOM));
      _this.props.onZoomChange && _this.props.onZoomChange(newZoom);
    }, _this.emitCropData = function () {
      if (!_this.state.cropSize) return;
      var croppedArea = _this.computeCroppedArea();
      var croppedAreaPixels = {
        x: croppedArea.x * _this.imageSize.naturalWidth / 100,
        y: croppedArea.y * _this.imageSize.naturalHeight / 100,
        width: croppedArea.width * _this.imageSize.naturalWidth / 100,
        height: croppedArea.height * _this.imageSize.naturalHeight / 100
      };
      _this.props.onCropComplete && _this.props.onCropComplete(croppedArea, croppedAreaPixels);
    }, _this.computeCroppedArea = function () {
      var _this$props = _this.props,
          _this$props$crop = _this$props.crop,
          x = _this$props$crop.x,
          y = _this$props$crop.y,
          zoom = _this$props.zoom;

      return {
        x: ((_this.imageSize.width - _this.state.cropSize.width / zoom) / 2 - x / zoom) / _this.imageSize.width * 100,
        y: ((_this.imageSize.height - _this.state.cropSize.height / zoom) / 2 - y / zoom) / _this.imageSize.height * 100,
        width: _this.state.cropSize.width / _this.imageSize.width * 100 / zoom,
        height: _this.state.cropSize.height / _this.imageSize.height * 100 / zoom
      };
    }, _this.recomputeCropPosition = function () {
      _this.props.onCropChange({
        x: Cropper.restrictDrag(_this.props.crop.x, _this.imageSize.width, _this.state.cropSize.width, _this.props.zoom),
        y: Cropper.restrictDrag(_this.props.crop.y, _this.imageSize.height, _this.state.cropSize.height, _this.props.zoom)
      });
      _this.emitCropData();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Cropper, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.computeSizes);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.computeSizes);
      this.cleanEvents();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.zoom !== this.props.zoom) {
        this.recomputeCropPosition();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$crop = _props.crop,
          x = _props$crop.x,
          y = _props$crop.y,
          zoom = _props.zoom;

      return _react2.default.createElement(
        _styles.Container,
        { onMouseDown: this.dragStart, onTouchStart: this.dragStart, onWheel: this.onWheel },
        _react2.default.createElement(_styles.Img, {
          src: this.props.image,
          innerRef: function innerRef(el) {
            return _this2.image = el;
          },
          onLoad: this.onImgLoad,
          alt: '',
          style: {
            transform: 'translate(' + x + 'px, ' + y + 'px) scale(' + zoom + ')'
          }
        }),
        this.state.cropSize && _react2.default.createElement(_styles.CropArea, {
          style: {
            width: this.state.cropSize.width,
            height: this.state.cropSize.height
          }
        })
      );
    }
  }], [{
    key: 'restrictDrag',
    value: function restrictDrag(position, imageSize, cropSize, zoom) {
      var maxDrag = imageSize * zoom / 2 - cropSize / 2;
      return Math.min(maxDrag, Math.max(position, -maxDrag));
    }

    /**
     * Compute the cropped area of the image in percent.
     * x and y are the center coordinates of the crop area.
     */

  }]);

  return Cropper;
}(_react2.default.Component);

Cropper.getEventXY = function (e) {
  return {
    x: Number(e.clientX || e.touches && e.touches[0].clientX),
    y: Number(e.clientY || e.touches && e.touches[0].clientY)
  };
};

Cropper.defaultProps = {
  zoom: 1,
  aspect: 4 / 3
};

exports.default = Cropper;